/// <reference types="react" />
import * as React from 'react';
import { ThemedComponentClass } from 'react-css-themr';
import { SVGSource } from '@shopify/images';
export declare type Color = ('white' | 'black' | 'skyLighter' | 'skyLight' | 'sky' | 'skyDark' | 'inkLightest' | 'inkLighter' | 'inkLight' | 'ink' | 'blueLighter' | 'blueLight' | 'blue' | 'blueDark' | 'blueDarker' | 'indigoLighter' | 'indigoLight' | 'indigo' | 'indigoDark' | 'indigoDarker' | 'tealLighter' | 'tealLight' | 'teal' | 'tealDark' | 'tealDarker' | 'greenLighter' | 'green' | 'greenDark' | 'yellowLighter' | 'yellow' | 'yellowDark' | 'orange' | 'redLighter' | 'red' | 'redDark' | 'purple');
export declare const BUNDLED_ICONS: {
    add: any;
    alert: any;
    arrowDown: any;
    arrowLeft: any;
    arrowRight: any;
    arrowUp: any;
    calendar: any;
    cancel: any;
    cancelSmall: any;
    caretDown: any;
    caretUp: any;
    chevronDown: any;
    chevronLeft: any;
    chevronRight: any;
    chevronUp: any;
    circleCancel: any;
    circleChevronDown: any;
    circleChevronLeft: any;
    circleChevronRight: any;
    circleChevronUp: any;
    circlePlus: any;
    conversation: any;
    delete: any;
    disable: any;
    dispute: any;
    duplicate: any;
    embed: any;
    export: any;
    external: any;
    horizontalDots: any;
    import: any;
    notes: any;
    print: any;
    refresh: any;
    risk: any;
    search: any;
    view: any;
};
export interface Props {
    source: SVGSource | 'placeholder' | keyof typeof BUNDLED_ICONS;
    color?: Color;
    backdrop?: boolean;
    accessibilityLabel?: string;
    style?: React.CSSProperties;
    theme?: any;
}
declare const _default: ThemedComponentClass<Props, {}>;
export default _default;
