/// <reference types="react" />
import * as React from 'react';
import { PreferredPosition } from '../PositionedOverlay';
import { CloseSource } from './PopoverOverlay';
export interface Props {
    children?: React.ReactNode;
    preferredPosition?: PreferredPosition;
    active: boolean;
    activator: React.ReactElement<any>;
    activatorWrapper?: string;
    preventAutofocus?: boolean;
    sectioned?: boolean;
    onClose?(source: CloseSource): void;
}
export interface State {
    activatorFocused: boolean;
}
export default class Popover extends React.PureComponent<Props, State> {
    state: State;
    private activatorNode;
    private activatorContainer;
    private id;
    componentDidMount(): void;
    componentDidUpdate(): void;
    renderLayer(): JSX.Element | null;
    render(): JSX.Element;
    private setAccessibilityAttributes();
    private handleClose(source);
    private setActivator(node);
}
