/// <reference types="react" />
import * as React from 'react';
import { ThemedComponentClass } from 'react-css-themr';
import { Rect } from '@shopify/javascript-utilities/geometry';
import { PreferredPosition } from './math';
export { PreferredPosition };
export declare type Positioning = 'above' | 'below';
export interface OverlayDetails {
    left: number;
    desiredHeight: number;
    positioning: Positioning;
    measuring: boolean;
    activatorRect: Rect;
}
export interface Props {
    active: boolean;
    activator: HTMLElement;
    preferredPosition?: PreferredPosition;
    theme?: any;
    render(overlayDetails: OverlayDetails): React.ReactNode;
    onScrollOut?(): void;
}
export interface State {
    measuring: boolean;
    activatorRect: Rect;
    left: number;
    top: number;
    height: number;
    positioning: Positioning;
    zIndex: number;
    outsideScrollableContainer: boolean;
}
declare const _default: ThemedComponentClass<Props, State>;
export default _default;
