import { Rect } from '@shopify/javascript-utilities/geometry';
export declare type PreferredPosition = 'above' | 'below' | 'mostSpace';
export interface Margins {
    activator: number;
    container: number;
    horizontal: number;
}
export declare function calculateVerticalPosition(activatorRect: Rect, overlayRect: Rect, overlayMargins: Margins, scrollableContainerRect: Rect, containerRect: Rect, preferredPosition: PreferredPosition): {
    height: number;
    top: number;
    positioning: string;
};
export declare function calculateHorizontalPosition(activatorRect: Rect, overlayRect: Rect, containerRect: Rect): number;
export declare function rectIsOutsideOfRect(inner: Rect, outer: Rect): boolean;
