/// <reference types="react" />
import * as React from 'react';
import { ThemedComponentClass } from 'react-css-themr';
import { Action, Error } from '../Labelled';
export declare type Option = string | {
    value: string;
    label: string;
};
export interface Group {
    title: string;
    options: Option[];
}
export interface Props {
    options?: Option[];
    groups?: (Group | Option)[];
    label: string;
    labelAction?: Action;
    labelHidden?: boolean;
    helpText?: React.ReactNode;
    id?: string;
    name?: string;
    error?: Error;
    disabled?: boolean;
    value?: string;
    placeholder?: string;
    theme?: any;
    onChange?(selected: string): void;
    onFocus?(): void;
    onBlur?(): void;
}
declare const Select: ({id, name, groups, options, labelHidden, labelAction, helpText, label, error, value, placeholder, disabled, onChange, onFocus, onBlur, theme}: Props) => JSX.Element;
export { Select as UnthemedSelect };
declare const _default: ThemedComponentClass<Props, {}>;
export default _default;
