/// <reference types="react" />
import * as React from 'react';
import { ThemedComponentClass } from 'react-css-themr';
import { Action } from '../Labelled';
export declare type Type = 'text' | 'email' | 'number' | 'password' | 'search' | 'tel' | 'url' | 'date' | 'datetime-local' | 'month' | 'time' | 'week';
export interface State {
    height?: number | null;
    focused?: boolean;
}
export interface Props {
    prefix?: React.ReactNode;
    suffix?: React.ReactNode;
    placeholder?: string;
    value?: string;
    helpText?: React.ReactNode;
    enableTextCouter?: boolean;
    label: string;
    labelAction?: Action;
    labelHidden?: boolean;
    disabled?: boolean;
    readOnly?: boolean;
    autoFocus?: boolean;
    multiline?: boolean | number;
    errors?: [string];
    connectedRight?: React.ReactNode;
    connectedLeft?: React.ReactNode;
    type?: Type;
    name?: string;
    id?: string;
    step?: number;
    autoComplete?: boolean;
    max?: number;
    maxLength?: number;
    min?: number;
    minLength?: number;
    pattern?: string;
    required?: boolean;
    spellCheck?: boolean;
    style?: React.CSSProperties;
    theme?: any;
    onChange?(value: string): void;
    onFocus?(): void;
    onBlur?(e?: any): void;
}
declare class TextField extends React.PureComponent<Props, State> {
    state: State;
    private input;
    render(): JSX.Element;
    private setInput(input);
    private handleNumberChange(steps);
    private handleExpandingResize(height);
    private handleChange(event);
    private handleInputOnFocus();
    private handleInputOnBlur(e);
    private handleInputFocus();
}
export { TextField as UnthemedTextField };
declare const _default: ThemedComponentClass<Props, State>;
export default _default;
